# Go API client for swagger

TollGuru Calculator API

## Overview
This API client was generated by the [swagger-codegen](https://github.com/swagger-api/swagger-codegen) project.  By using the [swagger-spec](https://github.com/swagger-api/swagger-spec) from a remote server, you can easily generate an API client.

- API version: 2020-07-15T09:40:00Z
- Package version: 1.0.0
- Build package: io.swagger.codegen.languages.GoClientCodegen
For more information, please visit [tollguru.com](tollguru.com)

## Installation
Put the package under your project folder and add the following in import:
```golang
import "./swagger"
```

## Documentation for API Endpoints

All URIs are relative to *https://dev.tollguru.com*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*GPSTracestracksApi* | [**RouteDownloadPost**](docs/GPSTracestracksApi.md#routedownloadpost) | **Post** /route/download | Download Async Results
*GPSTracestracksApi* | [**RouteUploadPost**](docs/GPSTracestracksApi.md#routeuploadpost) | **Post** /route/upload | Request
*OriginAndDestinationPairApi* | [**GmapsPost**](docs/OriginAndDestinationPairApi.md#gmapspost) | **Post** /gmaps | Google Maps Routes
*OriginAndDestinationPairApi* | [**HerePost**](docs/OriginAndDestinationPairApi.md#herepost) | **Post** /here | HERE Maps Routes
*RoutePolylineApi* | [**RoutePost**](docs/RoutePolylineApi.md#routepost) | **Post** /route | Route polyline (from HERE/ Google map)


## Documentation For Models

 - [Address](docs/Address.md)
 - [AsyncResponse](docs/AsyncResponse.md)
 - [Body](docs/Body.md)
 - [Body1](docs/Body1.md)
 - [Cost](docs/Cost.md)
 - [DateTime](docs/DateTime.md)
 - [Direction](docs/Direction.md)
 - [DirectionPosition](docs/DirectionPosition.md)
 - [Driver](docs/Driver.md)
 - [FuelEfficiency](docs/FuelEfficiency.md)
 - [GeoCordinates](docs/GeoCordinates.md)
 - [GmapRequestBody](docs/GmapRequestBody.md)
 - [GmapResponse](docs/GmapResponse.md)
 - [GmapResponseSummary](docs/GmapResponseSummary.md)
 - [GmapResponseSummaryFuelPrice](docs/GmapResponseSummaryFuelPrice.md)
 - [GmapRouteResponse](docs/GmapRouteResponse.md)
 - [GmapRouteResponseSummary](docs/GmapRouteResponseSummary.md)
 - [GmapRouteResponseSummaryDiffs](docs/GmapRouteResponseSummaryDiffs.md)
 - [GmapRouteResponseSummaryDistance](docs/GmapRouteResponseSummaryDistance.md)
 - [GmapRouteResponseSummaryDuration](docs/GmapRouteResponseSummaryDuration.md)
 - [HereRequestBody](docs/HereRequestBody.md)
 - [HereResponse](docs/HereResponse.md)
 - [HosData](docs/HosData.md)
 - [HosDataDistance](docs/HosDataDistance.md)
 - [HosDataDuration](docs/HosDataDuration.md)
 - [HosReq](docs/HosReq.md)
 - [HosResponse](docs/HosResponse.md)
 - [HosResponseSummary](docs/HosResponseSummary.md)
 - [InlineResponse200](docs/InlineResponse200.md)
 - [InlineResponse200Route](docs/InlineResponse200Route.md)
 - [InlineResponse200Summary](docs/InlineResponse200Summary.md)
 - [Location](docs/Location.md)
 - [PlaceId](docs/PlaceId.md)
 - [Rates](docs/Rates.md)
 - [Route](docs/Route.md)
 - [RouteLocation](docs/RouteLocation.md)
 - [RouteResponse](docs/RouteResponse.md)
 - [Stop](docs/Stop.md)
 - [SyncResponse](docs/SyncResponse.md)
 - [SyncResponseRoute](docs/SyncResponseRoute.md)
 - [TeritoryMielageRes](docs/TeritoryMielageRes.md)
 - [TeritoryMielageResInner](docs/TeritoryMielageResInner.md)
 - [TeritoryMielageResInnerTerritory](docs/TeritoryMielageResInnerTerritory.md)
 - [Timestamp](docs/Timestamp.md)
 - [Toll](docs/Toll.md)
 - [Truck](docs/Truck.md)
 - [VehicleType](docs/VehicleType.md)


## Documentation For Authorization

## authorizer
- **Type**: API key 

Example
```golang
auth := context.WithValue(context.Background(), sw.ContextAPIKey, sw.APIKey{
	Key: "APIKEY",
	Prefix: "Bearer", // Omit if not necessary.
})
r, err := client.Service.Operation(auth, args)
```

## Author

eng@tollguru.com

