
/*
 * TollGuru Calculator
 *
 * TollGuru Calculator API
 *
 * API version: 2020-07-15T09:40:00Z
 * Contact: eng@tollguru.com
 * Generated by: Swagger Codegen (https://github.com/swagger-api/swagger-codegen.git)
 */

package swagger

import (
	"context"
	"io/ioutil"
	"net/http"
	"net/url"
	"strings"
	"github.com/antihax/optional"
)

// Linger please
var (
	_ context.Context
)

type GPSTracestracksApiService service

/* 
GPSTracestracksApiService Download Async Results
The results will be available for download for upto 30 days by calling the API.
 * @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 * @param optional nil or *GPSTracestracksApiRouteDownloadPostOpts - Optional Parameters:
     * @param "Body" (optional.Interface of Body1) - 

@return SyncResponse
*/

type GPSTracestracksApiRouteDownloadPostOpts struct { 
	Body optional.Interface
}

func (a *GPSTracestracksApiService) RouteDownloadPost(ctx context.Context, localVarOptionals *GPSTracestracksApiRouteDownloadPostOpts) (SyncResponse, *http.Response, error) {
	var (
		localVarHttpMethod = strings.ToUpper("Post")
		localVarPostBody   interface{}
		localVarFileName   string
		localVarFileBytes  []byte
		localVarReturnValue SyncResponse
	)

	// create path and map variables
	localVarPath := a.client.cfg.BasePath + "/route/download"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHttpContentTypes := []string{"application/json"}

	// set Content-Type header
	localVarHttpContentType := selectHeaderContentType(localVarHttpContentTypes)
	if localVarHttpContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHttpContentType
	}

	// to determine the Accept header
	localVarHttpHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHttpHeaderAccept := selectHeaderAccept(localVarHttpHeaderAccepts)
	if localVarHttpHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHttpHeaderAccept
	}
	// body params
	if localVarOptionals != nil && localVarOptionals.Body.IsSet() {
		
		localVarOptionalBody, localVarOptionalBodyok := localVarOptionals.Body.Value().(Body1)
		if !localVarOptionalBodyok {
				return localVarReturnValue, nil, reportError("body should be Body1")
		}
		localVarPostBody = &localVarOptionalBody
	}
	r, err := a.client.prepareRequest(ctx, localVarPath, localVarHttpMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, localVarFileName, localVarFileBytes)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHttpResponse, err := a.client.callAPI(r)
	if err != nil || localVarHttpResponse == nil {
		return localVarReturnValue, localVarHttpResponse, err
	}

	localVarBody, err := ioutil.ReadAll(localVarHttpResponse.Body)
	localVarHttpResponse.Body.Close()
	if err != nil {
		return localVarReturnValue, localVarHttpResponse, err
	}

	if localVarHttpResponse.StatusCode < 300 {
		// If we succeed, return the data, otherwise pass on to decode error.
		err = a.client.decode(&localVarReturnValue, localVarBody, localVarHttpResponse.Header.Get("Content-Type"));
		if err == nil { 
			return localVarReturnValue, localVarHttpResponse, err
		}
	}

	if localVarHttpResponse.StatusCode >= 300 {
		newErr := GenericSwaggerError{
			body: localVarBody,
			error: localVarHttpResponse.Status,
		}
		
		if localVarHttpResponse.StatusCode == 200 {
			var v SyncResponse
			err = a.client.decode(&v, localVarBody, localVarHttpResponse.Header.Get("Content-Type"));
				if err != nil {
					newErr.error = err.Error()
					return localVarReturnValue, localVarHttpResponse, newErr
				}
				newErr.model = v
				return localVarReturnValue, localVarHttpResponse, newErr
		}
		
		return localVarReturnValue, localVarHttpResponse, newErr
	}

	return localVarReturnValue, localVarHttpResponse, nil
}

/* 
GPSTracestracksApiService Request
&lt;p&gt;This API can be used in synchronous and asynchronous modes. The default mode of operation is synchronous mode where the API response with toll information is returned immediately.&lt;/p&gt;&lt;p&gt;Asynchronous mode is used in the following cases: &lt;/p&gt;&lt;ul&gt; &lt;li&gt;Bulk upload of multiple GPS tracks files&lt;/li&gt;&lt;li&gt;Uploading large GPS tracks files&lt;/li&gt;&lt;/ul&gt;&lt;p&gt;In asynchronous mode, the response is returned immediately with a &lt;code&gt;requestId&lt;/code&gt; and &lt;code&gt;requestedTimestamp&lt;/code&gt;. The results will be available for download for upto 30 days by calling the &lt;code&gt;route/download&lt;/code&gt; API. Asynchronous mode can used by specifying the url parameter &lt;code&gt;isAsync&#x3D;true&lt;/code&gt;.&lt;/p&gt;&lt;p&gt;GPS traces can be passed in the following format &lt;/p&gt;&lt;ul&gt; &lt;li&gt;Upload CSV file&lt;/li&gt;&lt;li&gt;Upload kml file&lt;/li&gt;&lt;/ul&gt;&lt;p&gt;The first line in the CSV needs to contain the attribute names. The subsequent lines needs to contain the data in temporal order. The following parameters are available:&lt;/p&gt;&lt;table&gt;&lt;thead&gt;&lt;tr&gt;&lt;th&gt;Parameter&lt;/th&gt;&lt;th&gt;Description&lt;/th&gt;&lt;/tr&gt;&lt;/thead&gt;&lt;tbody&gt;&lt;tr&gt;&lt;td&gt;&lt;strong&gt;latitude&lt;/strong&gt;&lt;/td&gt;&lt;td&gt;Latitude coordinate in WGS84 degree (mandatory)&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;strong&gt;longitude&lt;/strong&gt;&lt;/td&gt;&lt;td&gt;Longitude coordinate in WGS84 degree (mandatory)&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;strong&gt;timestamp&lt;/strong&gt;&lt;/td&gt;&lt;td&gt;indicates the time and date, for example&amp;nbsp;&amp;nbsp;2018-05-21T17:05:06Z (mandatory since tolls may change based on time)&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;strong&gt;speed_mps&lt;/strong&gt;&lt;/td&gt;&lt;td&gt;speed in meters per second (optional)&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;strong&gt;speed_mph&lt;/strong&gt;&lt;/td&gt;&lt;td&gt;speed in miles per hour (optional)&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;strong&gt;speed_kmh&lt;/strong&gt;&lt;/td&gt;&lt;td&gt;speed in kilometers per hour (optional)&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;strong&gt;heading&lt;/strong&gt;&lt;/td&gt;&lt;td&gt;heading in degrees clockwise from North (optional)&lt;/td&gt;&lt;/tr&gt;&lt;/tbody&gt;&lt;/table&gt;&lt;p&gt;You can download sample file from &lt;a href&#x3D;\&quot;https://tollguru-cdn.s3.us-east-2.amazonaws.com/trip_route.csv\&quot; target&#x3D;\&quot;_blank\&quot;&gt;here&lt;/a&gt;&lt;/p&gt;&lt;p&gt;Or use the CSV format file as shown in the table below:&lt;/p&gt;&lt;table&gt; &lt;tr&gt; &lt;th&gt;latitude&lt;/th&gt; &lt;th&gt;longitude&lt;/th&gt; &lt;th&gt;timestamp&lt;/th&gt; &lt;/tr&gt;&lt;tr&gt; &lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;38.90479&lt;/td&gt;&lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;-77.02607&lt;/td&gt;&lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;2019-12-16T15:45:23Z&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt; &lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;38.90479&lt;/td&gt;&lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;-77.02606&lt;/td&gt;&lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;2019-12-16T15:47:24Z&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt; &lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;38.9048&lt;/td&gt;&lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;-77.02608&lt;/td&gt;&lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;2019-12-16T15:49:25Z&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt; &lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;38.9044&lt;/td&gt;&lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;-77.02604&lt;/td&gt;&lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;2019-12-16T15:50:42Z&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt; &lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;38.90424&lt;/td&gt;&lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;-77.02646&lt;/td&gt;&lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;2019-12-16T15:50:49Z&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt; &lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;38.90422&lt;/td&gt;&lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;-77.02686&lt;/td&gt;&lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;2019-12-16T15:50:55Z&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;
 * @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 * @param vehicleType
 * @param optional nil or *GPSTracestracksApiRouteUploadPostOpts - Optional Parameters:
     * @param "VehicleName" (optional.String) -  Specify name for your vehicle to identify the response json for particular vehicle
     * @param "Height" (optional.String) -  Specify the vehicle height to get accurate tolls for toll roads where tolls depend on axles and vehicle height
     * @param "Weight" (optional.String) -  Specify the vehicle weight to get accurate tolls for toll roads where tolls depend on axles and vehicle weight
     * @param "IsAsync" (optional.Bool) -  The API will function in asynchronous mode is set to true
     * @param "Body" (optional.String) - 

@return interface{}
*/

type GPSTracestracksApiRouteUploadPostOpts struct { 
	VehicleName optional.String
	Height optional.String
	Weight optional.String
	IsAsync optional.Bool
	Body optional.String
}

func (a *GPSTracestracksApiService) RouteUploadPost(ctx context.Context, vehicleType string, localVarOptionals *GPSTracestracksApiRouteUploadPostOpts) (interface{}, *http.Response, error) {
	var (
		localVarHttpMethod = strings.ToUpper("Post")
		localVarPostBody   interface{}
		localVarFileName   string
		localVarFileBytes  []byte
		localVarReturnValue interface{}
	)

	// create path and map variables
	localVarPath := a.client.cfg.BasePath + "/route/upload"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	localVarQueryParams.Add("vehicleType", parameterToString(vehicleType, ""))
	if localVarOptionals != nil && localVarOptionals.VehicleName.IsSet() {
		localVarQueryParams.Add("vehicleName", parameterToString(localVarOptionals.VehicleName.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.Height.IsSet() {
		localVarQueryParams.Add("height", parameterToString(localVarOptionals.Height.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.Weight.IsSet() {
		localVarQueryParams.Add("weight", parameterToString(localVarOptionals.Weight.Value(), ""))
	}
	if localVarOptionals != nil && localVarOptionals.IsAsync.IsSet() {
		localVarQueryParams.Add("isAsync", parameterToString(localVarOptionals.IsAsync.Value(), ""))
	}
	// to determine the Content-Type header
	localVarHttpContentTypes := []string{"text/csv"}

	// set Content-Type header
	localVarHttpContentType := selectHeaderContentType(localVarHttpContentTypes)
	if localVarHttpContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHttpContentType
	}

	// to determine the Accept header
	localVarHttpHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHttpHeaderAccept := selectHeaderAccept(localVarHttpHeaderAccepts)
	if localVarHttpHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHttpHeaderAccept
	}
	// body params
	if localVarOptionals != nil && localVarOptionals.Body.IsSet() {
		localVarPostBody = &localVarOptionals.Body.Value()
		
	}
	r, err := a.client.prepareRequest(ctx, localVarPath, localVarHttpMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, localVarFileName, localVarFileBytes)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHttpResponse, err := a.client.callAPI(r)
	if err != nil || localVarHttpResponse == nil {
		return localVarReturnValue, localVarHttpResponse, err
	}

	localVarBody, err := ioutil.ReadAll(localVarHttpResponse.Body)
	localVarHttpResponse.Body.Close()
	if err != nil {
		return localVarReturnValue, localVarHttpResponse, err
	}

	if localVarHttpResponse.StatusCode < 300 {
		// If we succeed, return the data, otherwise pass on to decode error.
		err = a.client.decode(&localVarReturnValue, localVarBody, localVarHttpResponse.Header.Get("Content-Type"));
		if err == nil { 
			return localVarReturnValue, localVarHttpResponse, err
		}
	}

	if localVarHttpResponse.StatusCode >= 300 {
		newErr := GenericSwaggerError{
			body: localVarBody,
			error: localVarHttpResponse.Status,
		}
		
		if localVarHttpResponse.StatusCode == 200 {
			var v interface{}
			err = a.client.decode(&v, localVarBody, localVarHttpResponse.Header.Get("Content-Type"));
				if err != nil {
					newErr.error = err.Error()
					return localVarReturnValue, localVarHttpResponse, newErr
				}
				newErr.model = v
				return localVarReturnValue, localVarHttpResponse, newErr
		}
		
		return localVarReturnValue, localVarHttpResponse, newErr
	}

	return localVarReturnValue, localVarHttpResponse, nil
}
