# \GPSTracestracksApi

All URIs are relative to *https://dev.tollguru.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**RouteDownloadPost**](GPSTracestracksApi.md#RouteDownloadPost) | **Post** /route/download | Download Async Results
[**RouteUploadPost**](GPSTracestracksApi.md#RouteUploadPost) | **Post** /route/upload | Request


# **RouteDownloadPost**
> SyncResponse RouteDownloadPost(ctx, optional)
Download Async Results

The results will be available for download for upto 30 days by calling the API.

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
 **optional** | ***GPSTracestracksApiRouteDownloadPostOpts** | optional parameters | nil if no parameters

### Optional Parameters
Optional parameters are passed through a pointer to a GPSTracestracksApiRouteDownloadPostOpts struct

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**optional.Interface of Body1**](Body1.md)|  | 

### Return type

[**SyncResponse**](SyncResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **RouteUploadPost**
> interface{} RouteUploadPost(ctx, vehicleType, optional)
Request

<p>This API can be used in synchronous and asynchronous modes. The default mode of operation is synchronous mode where the API response with toll information is returned immediately.</p><p>Asynchronous mode is used in the following cases: </p><ul> <li>Bulk upload of multiple GPS tracks files</li><li>Uploading large GPS tracks files</li></ul><p>In asynchronous mode, the response is returned immediately with a <code>requestId</code> and <code>requestedTimestamp</code>. The results will be available for download for upto 30 days by calling the <code>route/download</code> API. Asynchronous mode can used by specifying the url parameter <code>isAsync=true</code>.</p><p>GPS traces can be passed in the following format </p><ul> <li>Upload CSV file</li><li>Upload kml file</li></ul><p>The first line in the CSV needs to contain the attribute names. The subsequent lines needs to contain the data in temporal order. The following parameters are available:</p><table><thead><tr><th>Parameter</th><th>Description</th></tr></thead><tbody><tr><td><strong>latitude</strong></td><td>Latitude coordinate in WGS84 degree (mandatory)</td></tr><tr><td><strong>longitude</strong></td><td>Longitude coordinate in WGS84 degree (mandatory)</td></tr><tr><td><strong>timestamp</strong></td><td>indicates the time and date, for example&nbsp;&nbsp;2018-05-21T17:05:06Z (mandatory since tolls may change based on time)</td></tr><tr><td><strong>speed_mps</strong></td><td>speed in meters per second (optional)</td></tr><tr><td><strong>speed_mph</strong></td><td>speed in miles per hour (optional)</td></tr><tr><td><strong>speed_kmh</strong></td><td>speed in kilometers per hour (optional)</td></tr><tr><td><strong>heading</strong></td><td>heading in degrees clockwise from North (optional)</td></tr></tbody></table><p>You can download sample file from <a href=\"https://tollguru-cdn.s3.us-east-2.amazonaws.com/trip_route.csv\" target=\"_blank\">here</a></p><p>Or use the CSV format file as shown in the table below:</p><table> <tr> <th>latitude</th> <th>longitude</th> <th>timestamp</th> </tr><tr> <td style=\"text-align: center;\">38.90479</td><td style=\"text-align: center;\">-77.02607</td><td style=\"text-align: center;\">2019-12-16T15:45:23Z</td></tr><tr> <td style=\"text-align: center;\">38.90479</td><td style=\"text-align: center;\">-77.02606</td><td style=\"text-align: center;\">2019-12-16T15:47:24Z</td></tr><tr> <td style=\"text-align: center;\">38.9048</td><td style=\"text-align: center;\">-77.02608</td><td style=\"text-align: center;\">2019-12-16T15:49:25Z</td></tr><tr> <td style=\"text-align: center;\">38.9044</td><td style=\"text-align: center;\">-77.02604</td><td style=\"text-align: center;\">2019-12-16T15:50:42Z</td></tr><tr> <td style=\"text-align: center;\">38.90424</td><td style=\"text-align: center;\">-77.02646</td><td style=\"text-align: center;\">2019-12-16T15:50:49Z</td></tr><tr> <td style=\"text-align: center;\">38.90422</td><td style=\"text-align: center;\">-77.02686</td><td style=\"text-align: center;\">2019-12-16T15:50:55Z</td></tr></table>

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
  **vehicleType** | **string**|  | 
 **optional** | ***GPSTracestracksApiRouteUploadPostOpts** | optional parameters | nil if no parameters

### Optional Parameters
Optional parameters are passed through a pointer to a GPSTracestracksApiRouteUploadPostOpts struct

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------

 **vehicleName** | **optional.String**| Specify name for your vehicle to identify the response json for particular vehicle | 
 **height** | **optional.String**| Specify the vehicle height to get accurate tolls for toll roads where tolls depend on axles and vehicle height | 
 **weight** | **optional.String**| Specify the vehicle weight to get accurate tolls for toll roads where tolls depend on axles and vehicle weight | 
 **isAsync** | **optional.Bool**| The API will function in asynchronous mode is set to true | [default to false]
 **body** | **optional.String**|  | 

### Return type

[**interface{}**](interface{}.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: text/csv
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

