# \OriginAndDestinationPairApi

All URIs are relative to *https://dev.tollguru.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**GmapsPost**](OriginAndDestinationPairApi.md#GmapsPost) | **Post** /gmaps | Google Maps Routes
[**HerePost**](OriginAndDestinationPairApi.md#HerePost) | **Post** /here | HERE Maps Routes


# **GmapsPost**
> GmapResponse GmapsPost(ctx, optional)
Google Maps Routes

HTTP Request for cars, SUVs, pick-ups, motorcycles

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
 **optional** | ***OriginAndDestinationPairApiGmapsPostOpts** | optional parameters | nil if no parameters

### Optional Parameters
Optional parameters are passed through a pointer to a OriginAndDestinationPairApiGmapsPostOpts struct

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**optional.Interface of GmapRequestBody**](GmapRequestBody.md)|  | 

### Return type

[**GmapResponse**](GmapResponse.md)

### Authorization

[authorizer](../README.md#authorizer)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **HerePost**
> HereResponse HerePost(ctx, optional)
HERE Maps Routes

<p>HTTP Request for trucks, buses, RVs, cars, SUV, pick-ups, motorcycles</p><p>For trucks you should specify truck weight, wherever possible. Some bridges and tunnels restrict trucks based on weight. If you are transporting HAZMAT material, please specify material type. If you do not specify HAZMAT restrictions and weight restrictions, none will be applied.</p>

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
 **optional** | ***OriginAndDestinationPairApiHerePostOpts** | optional parameters | nil if no parameters

### Optional Parameters
Optional parameters are passed through a pointer to a OriginAndDestinationPairApiHerePostOpts struct

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**optional.Interface of HereRequestBody**](HereRequestBody.md)|  | 

### Return type

[**HereResponse**](HereResponse.md)

### Authorization

[authorizer](../README.md#authorizer)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

