# Truck

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**Height** | **float32** | Vehicle height in feet. The provided value must be between 0 and 50. &lt;br&gt; If vehicle height is not specified, incorrect tolls may be calculated on New York Thruway and other toll roads where tolls are based on axles and weight. | [optional] [default to null]
**Length** | **float32** | Vehicle length in feet. The provided value must be between 0 and 300. | [optional] [default to null]
**LimitedWeight** | **float32** | Vehicle weight including trailers and shipped goods, in pounds. &lt;br&gt; If truck weight is not specified, incorrect tolls may be calculated for trucks on Pennsylvania turnpike and other toll locations where tolls are based on weight. | [optional] [default to null]
**ShippedHazardousGoods** | **string** | List of hazardous materials in the vehicle. The names correspond to &lt;a href&#x3D;\&quot;https://www.fmcsa.dot.gov/sites/fmcsa.dot.gov/files/docs/Nine_Classes_of_Hazardous_Materials-4-2013_508CLN.pdf\&quot; target&#x3D;\&quot;_blank\&quot;&gt; HAZMAT classes 1 to 9. &lt;br&gt; For example, explosive is Class 1 and so on. &lt;/a&gt; | [optional] [default to null]
**TrailersCount** | **float32** | Specifies number of trailers pulled by a vehicle. The provided value must be between 0 and 4. | [optional] [default to null]
**TruckRestrictionPenalty** | **string** | pecifies the penalty type on violated truck restrictions.&lt;br&gt;&lt;code&gt;strict&lt;/code&gt;: route will not use links with a violated truck restriction at any circumstances&lt;br&gt;&lt;strong&gt;Note&lt;/strong&gt;: Route computation will fail and return NoRouteFound if not able to avoid the links with a violated truck restriction and the penalty type is strict.&lt;br&gt;&lt;code&gt;soft&lt;/code&gt;: route will use links with a violated truck restriction if there is no alternative to avoid them&lt; | [optional] [default to null]
**TruckType** | **string** | Specifies the vehicle type&lt;br&gt;&lt;strong&gt;Note&lt;/strong&gt;: Relevant for restrictions that apply exclusively to tractors with semi-trailers (observed in North America). Such restrictions are taken into account only in case of the &lt;code&gt;truckType&lt;/code&gt; set to &lt;code&gt;tractorTruck&lt;/code&gt; and the trailers count greater than 0 (for example &lt;code&gt;truckType: \&quot;tractorTruck\&quot;, trailersCount: 1&lt;/code&gt;). The truck type is irrelevant in case of restrictions common for all types of trucks. | [optional] [default to null]
**TunnelCategory** | **string** | Specifies the tunnel category to restrict certain route links. The route will pass only through tunnels of a less strict category. | [optional] [default to null]
**WeightPerAxle** | **float32** | Vehicle weight per axle in pounds. &lt;br&gt; If truck weight is not specified, incorrect tolls may be calculated for trucks on Pennsylvania turnpike and other toll locations where tolls are based on weight. | [optional] [default to null]
**Width** | **float32** | Vehicle width in feet. The provided value must be between 0 and 50. | [optional] [default to null]

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


