/*
 * TollGuru Calculator
 *
 * TollGuru Calculator API
 *
 * API version: 2020-07-15T09:40:00Z
 * Contact: eng@tollguru.com
 * Generated by: Swagger Codegen (https://github.com/swagger-api/swagger-codegen.git)
 */

package swagger

// Tolls object contains tolls for all the toll locations on the route. For each toll location
type Toll struct {
	// Cash toll cost
	CashCost float32 `json:"cashCost,omitempty"`
	// Credit card toll cost
	CreditCardCost float32 `json:"creditCardCost,omitempty"`
	// Currency
	Currency string `json:"currency,omitempty"`
	// Tollguru toll ID. Useful for error checking
	Id float32 `json:"id,omitempty"`
	// Approximate latitude of the toll location
	Lat float32 `json:"lat,omitempty"`
	// License plate (video) toll cost. For example, <a href=\"https://tollguru.com/toll-info/california/pay-by-plate-payment\" target=\"_blank\">Pay by Plate</a> in California, <a href=\"https://tollguru.com/toll-info/texas/pay-by-mail\" target=\"_blank\">ZipCash and Pay by Mail</a> in Texas, <a href=\"https://tollguru.com/toll-info/florida/video-payment\" target=\"_blank\">Pay by Plate</a> in Florida, <a href=\"https://tollguru.com/toll-info/colorado/video-payment\" target=\"_blank\">License Plate Toll</a> in Colorado, Camera Charges on ETR-407, etc.
	LicensePlateCost float32 `json:"licensePlateCost,omitempty"`
	// Name of the primary license plate toll (video toll) collection system. Typically license Plate tolls are not discounted.
	LicensePlatePrimary string `json:"licensePlatePrimary,omitempty"`
	// Name of the secondary license plate toll (video toll) collection system
	LicensePlateSecondary string `json:"licensePlateSecondary,omitempty"`
	// Approximate longitude of the toll location
	Lng float32 `json:"lng,omitempty"`
	// Name of the toll location
	Name string `json:"name,omitempty"`
	// Prepaid card such as Nexpress, Nexus Card, etc. toll cost
	PrepaidCardCost float32 `json:"prepaidCardCost,omitempty"`
	// Name of the toll road
	Road string `json:"road,omitempty"`
	// State, province of the toll location
	State string `json:"state,omitempty"`
	// Transponder toll cost <br>For example, <a href=\"https://tollguru.com/toll-info/new-york/what-is-e-zpass\" target=\"_blank\">E-ZPass</a>, <a href=\"https://tollguru.com/toll-info/texas/what-is-txtag-tolltag-eztag\" target=\"_blank\">TxTag</a>, <a href=\"https://tollguru.com/toll-info/california/what-is-fastrak\" target=\"_blank\">FasTrak</a>, <a href=\"https://tollguru.com/toll-info/florida/what-is-sunpass\" target=\"_blank\">SunPass</a>, <a href=\"https://tollguru.com/toll-info/california/what-is-fastrak\" target=\"_blank\">FasTrak</a>, <a href=\"https://tollguru.com/toll-info/colorado/what-is-expresstoll-go-pass\" target=\"_blank\">ExpressToll</a>, etc.
	TagCost float32 `json:"tagCost,omitempty"`
	// A primary transponder that can be used on the facility. Typically primary transponders have discounts for each usage or based on volume.
	TagPrimary []string `json:"tagPrimary,omitempty"`
	// All other transponders that can be used on the facility. Secondary transponders may not count towards discounts
	TagSecondary []string `json:"tagSecondary,omitempty"`
	// Toll type: <br><code>barrier</code> (for example <a href=\"https://tollguru.com/toll-info/texas/texas-toll-roads-bridges-express-lanes\" target=\"_blank\"> toll roads in Texas </a>), <br><code>ticketSystem</code> - ticket system (for example <a href=\"https://tollguru.com/toll-info/oklahoma/oklahoma-turnpikes\" target=\"_blank\"> toll roads in Oklahoma</a>), <br><code>distBased</code> – distance based (for example <a href=\"https://tollguru.com/toll-info/ontario/ontario-407-ETR-toll-highway-bridges-tunnels\" target=\"_blank\"> ETR 407 in Ontario, Canada</a>).
	Type_ string `json:"type,omitempty"`
}
