/*
 * TollGuru Calculator
 *
 * TollGuru Calculator API
 *
 * API version: 2020-07-15T09:40:00Z
 * Contact: eng@tollguru.com
 * Generated by: Swagger Codegen (https://github.com/swagger-api/swagger-codegen.git)
 */

package swagger

type Truck struct {
	// Vehicle height in feet. The provided value must be between 0 and 50. <br> If vehicle height is not specified, incorrect tolls may be calculated on New York Thruway and other toll roads where tolls are based on axles and weight.
	Height float32 `json:"height,omitempty"`
	// Vehicle length in feet. The provided value must be between 0 and 300.
	Length float32 `json:"length,omitempty"`
	// Vehicle weight including trailers and shipped goods, in pounds. <br> If truck weight is not specified, incorrect tolls may be calculated for trucks on Pennsylvania turnpike and other toll locations where tolls are based on weight.
	LimitedWeight float32 `json:"limitedWeight,omitempty"`
	// List of hazardous materials in the vehicle. The names correspond to <a href=\"https://www.fmcsa.dot.gov/sites/fmcsa.dot.gov/files/docs/Nine_Classes_of_Hazardous_Materials-4-2013_508CLN.pdf\" target=\"_blank\"> HAZMAT classes 1 to 9. <br> For example, explosive is Class 1 and so on. </a>
	ShippedHazardousGoods string `json:"shippedHazardousGoods,omitempty"`
	// Specifies number of trailers pulled by a vehicle. The provided value must be between 0 and 4.
	TrailersCount float32 `json:"trailersCount,omitempty"`
	// pecifies the penalty type on violated truck restrictions.<br><code>strict</code>: route will not use links with a violated truck restriction at any circumstances<br><strong>Note</strong>: Route computation will fail and return NoRouteFound if not able to avoid the links with a violated truck restriction and the penalty type is strict.<br><code>soft</code>: route will use links with a violated truck restriction if there is no alternative to avoid them<
	TruckRestrictionPenalty string `json:"truckRestrictionPenalty,omitempty"`
	// Specifies the vehicle type<br><strong>Note</strong>: Relevant for restrictions that apply exclusively to tractors with semi-trailers (observed in North America). Such restrictions are taken into account only in case of the <code>truckType</code> set to <code>tractorTruck</code> and the trailers count greater than 0 (for example <code>truckType: \"tractorTruck\", trailersCount: 1</code>). The truck type is irrelevant in case of restrictions common for all types of trucks.
	TruckType string `json:"truckType,omitempty"`
	// Specifies the tunnel category to restrict certain route links. The route will pass only through tunnels of a less strict category.
	TunnelCategory string `json:"tunnelCategory,omitempty"`
	// Vehicle weight per axle in pounds. <br> If truck weight is not specified, incorrect tolls may be calculated for trucks on Pennsylvania turnpike and other toll locations where tolls are based on weight.
	WeightPerAxle float32 `json:"weightPerAxle,omitempty"`
	// Vehicle width in feet. The provided value must be between 0 and 50.
	Width float32 `json:"width,omitempty"`
}
